Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OFF_SRC/nemogcm.F90
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OFF_SRC/nemogcm.F90	(revision 7199)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OFF_SRC/nemogcm.F90	(revision 7200)
@@ -2,22 +2,27 @@
    !!======================================================================
    !!                       ***  MODULE nemogcm   ***
-   !! Off-line Ocean   : passive tracer evolution, dynamics read in files
+   !! OFF-line Ocean   : passive tracer evolution, dynamics read in files
    !!======================================================================
    !! History :  3.3  ! 2010-05  (C. Ethe)  Full reorganization of the off-line: phasing with the on-line
    !!            4.0  ! 2011-01  (C. Ethe, A. R. Porter, STFC Daresbury) dynamical allocation
+   !!            4.0  ! 2016-10  (C. Ethe, G. Madec, S. Flavoni)  domain configuration / user defined interface
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   nemo_gcm        : off-line: solve ocean tracer only
-   !!   nemo_init       : initialization of the nemo model
-   !!   nemo_ctl        : initialisation of algorithm flag 
-   !!   nemo_closefile  : close remaining files
+   !!   nemo_gcm      : solve ocean dynamics, tracer, biogeochemistry and/or sea-ice
+   !!   nemo_init     : initialization of the NEMO system
+   !!   nemo_ctl      : initialisation of the contol print
+   !!   nemo_closefile: close remaining open files
+   !!   nemo_alloc    : dynamical allocation
+   !!   nemo_partition: calculate MPP domain decomposition
+   !!   factorise     : calculate the factors of the no. of MPI processes
+   !!   istate_init   : ocean variables set to zero
+   !!   stp_ctl       : step control for OFF-line
    !!----------------------------------------------------------------------
    USE dom_oce         ! ocean space domain variables
    USE oce             ! dynamics and tracers variables
    USE c1d             ! 1D configuration
-   USE domcfg          ! domain configuration               (dom_cfg routine)
    USE domain          ! domain initialization from coordinate & bathymetry (dom_init routine)
-!   USE domrea          ! domain initialization from mesh_mask            (dom_init routine)
+   USE usrdef_nam     ! user defined configuration
    USE eosbn2          ! equation of state            (eos bn2 routine)
    !              ! ocean physics
@@ -35,4 +40,11 @@
    USE trcstp          ! passive tracer time-stepping      (trc_stp routine)
    USE dtadyn          ! Lecture and interpolation of the dynamical fields
+   !              ! Passive tracers needs
+   USE trc             ! passive tracer : variables
+   USE trcnam          ! passive tracer : namelist
+   USE trcrst          ! passive tracer restart
+   USE diaptr          ! Need to initialise this as some variables are used in if statements later
+   USE sbc_oce  , ONLY : ln_rnf
+   USE sbcrnf          ! surface boundary condition : runoffs
    !              ! I/O & MPP
    USE iom             ! I/O library
@@ -48,13 +60,4 @@
    USE lbcnfd, ONLY: isendto, nsndto, nfsloop, nfeloop ! Setup of north fold exchanges
 
-   USE trc
-   USE trcnam
-   USE trcrst
-   USE diaptr         ! Need to initialise this as some variables are used in if statements later
-   USE sbc_oce, ONLY: ln_rnf
-   USE sbcrnf
-   USE usrdef_nam     ! user defined configuration
-
-
    IMPLICIT NONE
    PRIVATE
@@ -65,5 +68,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OFF 3.3 , NEMO Consortium (2010)
+   !! NEMO/OFF 4.0 , NEMO Consortium (2016)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -75,6 +78,6 @@
       !!                     ***  ROUTINE nemo_gcm  ***
       !!
-      !! ** Purpose :   nemo solves the primitive equations on an orthogonal
-      !!      curvilinear mesh on the sphere.
+      !! ** Purpose :   NEMO solves the primitive equations on an orthogonal
+      !!              curvilinear mesh on the sphere.
       !!
       !! ** Method  : - model general initialization
@@ -85,8 +88,10 @@
       !!              Madec, 2008, internal report, IPSL.
       !!----------------------------------------------------------------------
-      INTEGER :: istp, indic       ! time step index
-      !!----------------------------------------------------------------------
-
-      CALL nemo_init  ! Initializations
+      INTEGER :: istp, indic   ! time step index
+      !!----------------------------------------------------------------------
+
+      !                            !-----------------------!
+      CALL nemo_init               !==  Initialisations  ==!
+      !                            !-----------------------!
 
       ! check that all process are still there... If some process have an error,
@@ -121,7 +126,7 @@
       !                            !==  finalize the run  ==!
       !                            !------------------------!
-      IF(lwp) WRITE(numout,cform_aaa)                 ! Flag AAAAAAA
-
-      IF( nstop /= 0 .AND. lwp ) THEN                 ! error print
+      IF(lwp) WRITE(numout,cform_aaa)        ! Flag AAAAAAA
+      !
+      IF( nstop /= 0 .AND. lwp ) THEN        ! error print
          WRITE(numout,cform_err)
          WRITE(numout,*) nstop, ' error have been found'
@@ -132,9 +137,9 @@
       CALL nemo_closefile
       !
-# if defined key_iomput
-      CALL xios_finalize             ! end mpp communications
-# else
-      IF( lk_mpp )   CALL mppstop       ! end mpp communications
-# endif
+#if defined key_iomput
+      CALL xios_finalize                     ! end mpp communications
+#else
+      IF( lk_mpp )   CALL mppstop            ! end mpp communications
+#endif
       !
    END SUBROUTINE nemo_gcm
@@ -143,20 +148,19 @@
    SUBROUTINE nemo_init
       !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE nemo_init ***
-      !!
-      !! ** Purpose :   initialization of the nemo model in off-line mode
-      !!----------------------------------------------------------------------
-      INTEGER ::   ji            ! dummy loop indices
-      INTEGER ::   ilocal_comm   ! local integer
-      INTEGER ::   ios, inum
-      REAL(wp) ::   ziglo, zjglo, zkglo, zperio   ! local scalars
+      !!                     ***  ROUTINE nemo_init  ***
+      !!
+      !! ** Purpose :   initialization of NEMO in off-line mode
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ji            ! dummy loop indices
+      INTEGER  ::   ilocal_comm   ! local integer
+      INTEGER  ::   ios, inum     !   -      -
       CHARACTER(len=120), DIMENSION(30) ::   cltxt, cltxt2, clnam
-      !!
-      NAMELIST/namctl/ ln_ctl  , nn_print, nn_ictls, nn_ictle,   &
-         &             nn_isplt, nn_jsplt, nn_jctls, nn_jctle,   &
+      !
+      NAMELIST/namctl/ ln_ctl   , nn_print, nn_ictls, nn_ictle,   &
+         &             nn_isplt , nn_jsplt, nn_jctls, nn_jctle,   &
          &             nn_timing, nn_diacfl
-
-      NAMELIST/namcfg/ ln_read_cfg, ln_write_cfg, cp_cfg, jp_cfg, ln_use_jattr
-      !!----------------------------------------------------------------------
+      NAMELIST/namcfg/ ln_read_cfg, cn_domcfg, ln_write_cfg, cn_domcfg_out, ln_use_jattr
+      !!----------------------------------------------------------------------
+      !
       cltxt  = ''
       cltxt2 = ''
@@ -168,14 +172,13 @@
       CALL ctl_opn( numnam_cfg, 'namelist_cfg', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE. )
       !
-      REWIND( numnam_ref )              ! Namelist namctl in reference namelist : Control prints & Benchmark
+      REWIND( numnam_ref )              ! Namelist namctl in reference namelist : Control prints
       READ  ( numnam_ref, namctl, IOSTAT = ios, ERR = 901 )
 901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namctl in reference namelist', .TRUE. )
-
-      REWIND( numnam_cfg )              ! Namelist namctl in confguration namelist : Control prints & Benchmark
+      !
+      REWIND( numnam_cfg )              ! Namelist namctl in confguration namelist
       READ  ( numnam_cfg, namctl, IOSTAT = ios, ERR = 902 )
 902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namctl in configuration namelist', .TRUE. )
-
-      !
-      REWIND( numnam_ref )              ! Namelist namcfg in reference namelist : Control prints & Benchmark
+      !
+      REWIND( numnam_ref )              ! Namelist namcfg in reference namelist : Control prints
       READ  ( numnam_ref, namcfg, IOSTAT = ios, ERR = 903 )
 903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfg in reference namelist', .TRUE. )
@@ -185,22 +188,12 @@
 904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfg in configuration namelist', .TRUE. )   
 
-
       !                             !--------------------------!
       !                             !  Set global domain size  !   (control print return in cltxt2)
       !                             !--------------------------!
-      IF( ln_read_cfg ) THEN              ! Read sizes in configuration "mesh_mask" file
-         CALL iom_open( 'domain_cfg', inum )
-         CALL iom_get( inum, 'jpiglo', ziglo  )   ;   jpiglo = INT( ziglo )
-         CALL iom_get( inum, 'jpjglo', zjglo  )   ;   jpjglo = INT( zjglo )
-         CALL iom_get( inum, 'jpkglo', zkglo  )   ;   jpkglo = INT( zkglo )
-         CALL iom_get( inum, 'jperio', zperio )   ;   jperio = INT( zperio )
-         CALL iom_close( inum )
-         WRITE(cltxt2(1),*) '~~~~~~~~~~   '      
-         WRITE(cltxt2(2),*) 'domain_cfg : domain size read in "domain_cfg" file : jp(i,j,k)glo = '
-         WRITE(cltxt2(3),*) '            ', jpiglo, jpjglo, jpkglo        
-         WRITE(cltxt2(1),*) '~~~~~~~~~~   lateral boudary type of the global domain jperio= ', jperio
-         !        
+      IF( ln_read_cfg ) THEN              ! Read sizes in domain configuration file
+         CALL domain_cfg ( cltxt2, clnam, cn_cfg, nn_cfg, jpiglo, jpjglo, jpkglo, jperio )
+         !
       ELSE                                ! user-defined namelist
-         CALL usr_def_nam( cltxt2, clnam, jpiglo, jpjglo, jpkglo, jperio )
+         CALL usr_def_nam( cltxt2, clnam, cn_cfg, nn_cfg, jpiglo, jpjglo, jpkglo, jperio )
       ENDIF
       jpk    = jpkglo
@@ -224,28 +217,27 @@
       lwp = (narea == 1) .OR. ln_ctl          ! control of all listing output print
 
-      IF(lwm) THEN
-         ! write merged namelists from earlier to output namelist now that the
-         ! file has been opened in call to mynode. nammpp has already been
-         ! written in mynode (if lk_mpp_mpi)
+      IF(lwm) THEN               ! write merged namelists from earlier to output namelist 
+         !                       ! now that the file has been opened in call to mynode. 
+         !                       ! NB: nammpp has already been written in mynode (if lk_mpp_mpi)
          WRITE( numond, namctl )
          WRITE( numond, namcfg )
          IF( .NOT.ln_read_cfg ) THEN
             DO ji = 1, SIZE(clnam)
-               IF( TRIM(clnam (ji)) /= '' )   WRITE(numond, * ) clnam(ji)    ! namusr_def print
+               IF( TRIM(clnam(ji)) /= '' )   WRITE(numond, * ) clnam(ji)     ! namusr_def print
             END DO
          ENDIF
       ENDIF
 
-      ! If dimensions of processor grid weren't specified in the namelist file 
+      ! If dimensions of processor grid weren't specified in the namelist file
       ! then we calculate them here now that we have our communicator size
-      IF( (jpni < 1) .OR. (jpnj < 1) )THEN
-#if   defined key_mpp_mpi
-         CALL nemo_partition(mppsize)
+      IF( jpni < 1 .OR. jpnj < 1 ) THEN
+#if defined key_mpp_mpi
+         CALL nemo_partition( mppsize )
 #else
-         jpni = 1
-         jpnj = 1
+         jpni  = 1
+         jpnj  = 1
          jpnij = jpni*jpnj
 #endif
-      END IF
+      ENDIF
 
       ! Calculate domain dimensions given calculated jpni and jpnj
@@ -259,5 +251,4 @@
       jpij  = jpi*jpj                                          !  jpi x j
 
-
       IF(lwp) THEN                            ! open listing units
          !
@@ -268,23 +259,26 @@
          WRITE(numout,*) '                       NEMO team'
          WRITE(numout,*) '            Ocean General Circulation Model'
-         WRITE(numout,*) '                  version 3.6  (2015) '
+         WRITE(numout,*) '                  version 3.7  (2016) '
          WRITE(numout,*)
          WRITE(numout,*)
-         DO ji = 1, SIZE(cltxt) 
-            IF( TRIM(cltxt(ji)) /= '' )   WRITE(numout,*) cltxt(ji)      ! control print of mynode
+         DO ji = 1, SIZE(cltxt)
+            IF( TRIM(cltxt (ji)) /= '' )   WRITE(numout,*) cltxt(ji)    ! control print of mynode
          END DO
-         WRITE(numout,cform_aaa)                                         ! Flag AAAAAAA
+         WRITE(numout,*)
+         WRITE(numout,*)
+         DO ji = 1, SIZE(cltxt2)
+            IF( TRIM(cltxt2(ji)) /= '' )   WRITE(numout,*) cltxt2(ji)   ! control print of domain size
+         END DO
+         WRITE(numout,cform_aaa)                                        ! Flag AAAAAAA
          !
       ENDIF
 
-      ! Now we know the dimensions of the grid and numout has been set we can 
-      ! allocate arrays
+      ! Now we know the dimensions of the grid and numout has been set: we can allocate arrays
       CALL nemo_alloc()
-
-      !                             !--------------------------------!
-      !                             !  Model general initialization  !
-      !                             !--------------------------------!
-
-      CALL nemo_ctl                           ! Control prints & Benchmark
+      !                             !-------------------------------!
+      !                             !  NEMO general initialization  !
+      !                             !-------------------------------!
+
+      CALL nemo_ctl                          ! Control prints
 
       !                                      ! Domain decomposition
@@ -295,5 +289,4 @@
       IF( nn_timing == 1 )  CALL timing_init
       !
-
       !                                      ! General initialization
       IF( nn_timing == 1 )  CALL timing_start( 'nemo_init')
@@ -374,8 +367,9 @@
          WRITE(numout,*) '~~~~~~~ '
          WRITE(numout,*) '   Namelist namcfg'
-         WRITE(numout,*) '      read configuration definition files          ln_read_cfg = ', ln_read_cfg
-         WRITE(numout,*) '      configuration name                               cp_cfg  = ', TRIM(cp_cfg)
-         WRITE(numout,*) '      configuration resolution                         jp_cfg  = ', jp_cfg
-         WRITE(numout,*) '      use file attribute if exists as i/p j-start ln_use_jattr = ', ln_use_jattr
+         WRITE(numout,*) '      read domain configuration files               ln_read_cfg      = ', ln_read_cfg
+         WRITE(numout,*) '         filename to be read                           cn_domcfg     = ', TRIM(cn_domcfg)
+         WRITE(numout,*) '      write  configuration definition files         ln_write_cfg     = ', ln_write_cfg
+         WRITE(numout,*) '         filename to be written                        cn_domcfg_out = ', TRIM(cn_domcfg_out)
+         WRITE(numout,*) '      use file attribute if exists as i/p j-start   ln_use_jattr     = ', ln_use_jattr
       ENDIF
       !                             ! Parameter control
@@ -432,5 +426,5 @@
       !!----------------------------------------------------------------------
       !
-      IF ( lk_mpp ) CALL mppsync
+      IF( lk_mpp )   CALL mppsync
       !
       CALL iom_close                                 ! close all input/output files managed by iom_*
@@ -455,5 +449,5 @@
       !! ** Method  :
       !!----------------------------------------------------------------------
-      USE diawri,       ONLY: dia_wri_alloc
+      USE diawri ,      ONLY: dia_wri_alloc
       USE dom_oce,      ONLY: dom_oce_alloc
       USE zdf_oce,      ONLY: zdf_oce_alloc
@@ -484,5 +478,5 @@
       !! ** Method  :
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) :: num_pes ! The number of MPI processes we have
+      INTEGER, INTENT(in) ::   num_pes   ! The number of MPI processes we have
       !
       INTEGER, PARAMETER :: nfactmax = 20
@@ -493,9 +487,9 @@
       INTEGER, DIMENSION(nfactmax) :: ifact ! Array of factors
       !!----------------------------------------------------------------------
-
+      !
       ierr = 0
-
+      !
       CALL factorise( ifact, nfactmax, nfact, num_pes, ierr )
-
+      !
       IF( nfact <= 1 ) THEN
          WRITE (numout, *) 'WARNING: factorisation of number of PEs failed'
@@ -528,5 +522,5 @@
       !!
       !! ** Purpose :   return the prime factors of n.
-      !!                knfax factors are returned in array kfax which is of 
+      !!                knfax factors are returned in array kfax which is of
       !!                maximum dimension kmaxfax.
       !! ** Method  :
@@ -538,16 +532,15 @@
       INTEGER :: ifac, jl, inu
       INTEGER, PARAMETER :: ntest = 14
-      INTEGER :: ilfax(ntest)
+      INTEGER, DIMENSION(ntest) ::   ilfax
+      !!----------------------------------------------------------------------
       !
       ! lfax contains the set of allowed factors.
-      data (ilfax(jl),jl=1,ntest) / 16384, 8192, 4096, 2048, 1024, 512, 256,  &
-         &                            128,   64,   32,   16,    8,   4,   2  /
-      !!----------------------------------------------------------------------
-
+      ilfax(:) = (/(2**jl,jl=ntest,1,-1)/)
+      !
       ! Clear the error flag and initialise output vars
-      kerr = 0
-      kfax = 1
+      kerr  = 0
+      kfax  = 1
       knfax = 0
-
+      !
       ! Find the factors of n.
       IF( kn == 1 )   GOTO 20
@@ -557,8 +550,8 @@
       ! l points to the allowed factor list.
       ! ifac holds the current factor.
-
+      !
       inu   = kn
       knfax = 0
-
+      !
       DO jl = ntest, 1, -1
          !
@@ -584,5 +577,5 @@
          !
       END DO
-
+      !
    20 CONTINUE      ! Label 20 is the exit point from the factor search loop.
       !
@@ -590,28 +583,26 @@
 
 #if defined key_mpp_mpi
+
    SUBROUTINE nemo_northcomms
-      !!======================================================================
+      !!----------------------------------------------------------------------
       !!                     ***  ROUTINE  nemo_northcomms  ***
-      !! nemo_northcomms    :  Setup for north fold exchanges with explicit 
-      !!                       point-to-point messaging
-      !!=====================================================================
-      !!----------------------------------------------------------------------
-      !!
-      !! ** Purpose :   Initialization of the northern neighbours lists.
+      !! ** Purpose :   Setup for north fold exchanges with explicit 
+      !!                point-to-point messaging
+      !!
+      !! ** Method :   Initialization of the northern neighbours lists.
       !!----------------------------------------------------------------------
       !!    1.0  ! 2011-10  (A. C. Coward, NOCS & J. Donners, PRACE)
-      !!    2.0  ! 2013-06 Setup avoiding MPI communication (I. Epicoco, S.
-      !Mocavero, CMCC) 
-      !!----------------------------------------------------------------------
-
+      !!    2.0  ! 2013-06 Setup avoiding MPI communication (I. Epicoco, S. Mocavero, CMCC) 
+      !!----------------------------------------------------------------------
       INTEGER  ::   sxM, dxM, sxT, dxT, jn
       INTEGER  ::   njmppmax
-
+      !!----------------------------------------------------------------------
+      !
       njmppmax = MAXVAL( njmppt )
-
+      !
       !initializes the north-fold communication variables
       isendto(:) = 0
-      nsndto = 0
-
+      nsndto     = 0
+      !
       !if I am a process in the north
       IF ( njmpp == njmppmax ) THEN
@@ -625,5 +616,5 @@
           !loop over the other north-fold processes to find the processes
           !managing the points belonging to the sxT-dxT range
-
+  
           DO jn = 1, jpni
                 !sxT is the first point (in the global domain) of the jn
@@ -660,4 +651,5 @@
       l_north_nogather = .TRUE.
    END SUBROUTINE nemo_northcomms
+
 #else
    SUBROUTINE nemo_northcomms      ! Dummy routine
@@ -686,4 +678,5 @@
    END SUBROUTINE istate_init
 
+
    SUBROUTINE stp_ctl( kt, kindic )
       !!----------------------------------------------------------------------
@@ -712,4 +705,5 @@
       !
    END SUBROUTINE stp_ctl
+
    !!======================================================================
 END MODULE nemogcm
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90	(revision 7199)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90	(revision 7200)
@@ -85,31 +85,31 @@
       !  mesh, only glamt and gphit   !
       ! ============================= !
-
+      !
       SELECT CASE( jphgr_msh )   ! type of horizontal mesh
-
+      !
       CASE ( 0 )                 !  curvilinear coordinate on the sphere read in coordinate.nc file
-
+         !
          CALL iom_open( 'coordinates', inum )
          CALL iom_get( inum, jpdom_unknown, 'glamt', glamdta ) ! mig, mjg undefined at this point
          CALL iom_get( inum, jpdom_unknown, 'gphit', gphidta ) ! so use jpdom_unknown not jpdom_data
          CALL iom_close ( inum )
-
+         !
       CASE ( 1 )                 ! geographical mesh on the sphere with regular grid-spacing
-
+         !
          DO jj = 1, jpjdta
             DO ji = 1, jpidta
                zti = FLOAT( ji - 1 + nimpp - 1 )
                ztj = FLOAT( jj - 1 + njmpp - 1 )
-
+               !
                glamdta(ji,jj) = ppglam0 + ppe1_deg * zti
                gphidta(ji,jj) = ppgphi0 + ppe2_deg * ztj
             END DO
          END DO
-
+         !
       CASE ( 2:3 )               ! f- or beta-plane with regular grid-spacing
-         
+         !
          glam0 = 0.e0
          gphi0 = - ppe2_m * 1.e-3
-
+         !
          DO jj = 1, jpjdta
             DO ji = 1, jpidta
@@ -118,36 +118,36 @@
             END DO
          END DO
-
+         !
       CASE ( 4 )                 ! geographical mesh on the sphere, isotropic MERCATOR type
-
+         !
          IF( ppgphi0 == -90 )   CALL ctl_stop( ' Mercator grid cannot start at south pole !!!! ' )
-
+         !
          zarg = rpi / 4. - rpi / 180. * ppgphi0 / 2.
          ijeq = ABS( 180. / rpi * LOG( COS( zarg ) / SIN( zarg ) ) / ppe1_deg )
          IF( ppgphi0 > 0 )   ijeq = -ijeq
-
+         !
          DO jj = 1, jpjdta
             DO ji = 1, jpidta
                zti = FLOAT( ji - 1    + nimpp - 1 )
                ztj = FLOAT( jj - ijeq + njmpp - 1 )
-
+               !
                glamdta(ji,jj) = ppglam0 + ppe1_deg * zti
                gphidta(ji,jj) = 1. / rad * ASIN ( TANH( ppe1_deg * rad * ztj ) )
             END DO
          END DO
-
+         !
       CASE ( 5 )                 ! beta-plane with regular grid-spacing and rotated domain (GYRE configuration)
-   
+         !
          zlam1 = -85
          zphi1 = 29
-         ze1 = 106000. / FLOAT(jp_cfg)
- 
+         ze1 = 106000. / REAL( nn_cfg , wp )
+         !
          zsin_alpha = - SQRT( 2. ) / 2.
          zcos_alpha =   SQRT( 2. ) / 2.
          ze1deg = ze1 / (ra * rad)
-
+         !
          glam0 = zlam1 + zcos_alpha * ze1deg * FLOAT( jpjdta-2 ) ! Force global
          gphi0 = zphi1 + zsin_alpha * ze1deg * FLOAT( jpjdta-2 )
-
+         !
          DO jj = 1, jpjdta
             DO ji = 1, jpidta
@@ -159,10 +159,10 @@
             END DO
          END DO
-
+         !
       CASE DEFAULT
-
+         !
          WRITE(ctmp1,*) '          bad flag value for jphgr_msh = ', jphgr_msh
          CALL ctl_stop( ctmp1 )
-
+         !
       END SELECT
 
